const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const terms = sequelize.define(
    'terms',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

term_name: {
        type: DataTypes.ENUM,
      
      

        values: [

"term_1",


"term_2",


"term_3"

        ],

      },

starts_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  terms.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






















    db.terms.hasMany(db.exams, {
      as: 'exams_term',
      foreignKey: {
          name: 'termId',
      },
      constraints: false,
    });

















//end loop



    db.terms.belongsTo(db.school_years, {
      as: 'school_year',
      foreignKey: {
        name: 'school_yearId',
      },
      constraints: false,
    });




    db.terms.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.terms.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return terms;
};


